<?/*

 Originally written by Stefano Fabri <bluefuture@nospam@email.it>
 Copyright 2004, Stefano Fabri

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <meta content="text/html; charset=ISO-8859-1"
 http-equiv="content-type">
  <title>Sources with newer upstream versions</title>
  <link rel="shortcut icon" href="/favicon.ico">
</head>
<body>
<div style="text-align: center;">
<h1><img src="http://www.debian.org/logos/openlogo-nd-50.png" style="border:0px;" alt='' height='30.5px' width='25px'>&nbsp;<a href="http://dehs.alioth.debian.org/" style="color:black;font-size:35px">Debian External Health Status</a>&nbsp;<img src="/earth.png" style="border:0px;" alt='' height='30.5px' width='30.5px'></h1>
Most popular packages that are not in sync with Upstream author version<br>
<?include("menu.inc");?>
<?
require("config_www.inc");
$rsql=pg_exec($db,
"Select id,pkgs.pop_inst,name,version, tot_up_error,tot_avg_error_date,pkgs.dist,up_version,watch_warn, up_changes,dversionmangled from pkgs
INNER join (Select SUM(up_error) as tot_up_error,AVG(avg_error_date) as tot_avg_error_date,name,dist FROM binpkgs GROUP BY name,dist) as binpkgs using(name,dist)
where updated='0' AND up_version!=''
order by pop_inst desc;") OR Die("Error on query");;
$rsql2=pg_exec($db, "SELECT count(name) from pkgs WHERE up_version IS NOT NULL") OR Die("Errore on query");
$totnowatch=pg_numrows($rsql);
$totpkgs=pg_fetch_array($rsql2,0);
print "<b>Total packages to be updated</b>: $totnowatch
		<b>Total with upstream version:</b> $totpkgs[0] <b>Share: </b> " . number_format ( $totnowatch/$totpkgs[0] * 100, 2) . "%" ;
?>
<table
 style="width: auto; text-align: left; margin-left: auto; margin-right: auto;"
 border="1" cellspacing="2" cellpadding="2">
  <tbody>
    <tr>
      <td
 style="vertical-align: top; text-align: center; font-weight: bold;">Pop Inst</td>
      <td style="vertical-align: top;text-align: center; font-weight: bold;">Name</td>
	   <td style="vertical-align: top; text-align: center; font-weight: bold;">Upstream Version</td>
	    <td style="vertical-align: top; text-align: center; font-weight: bold;">Debian Version</td>
		<td style="vertical-align: top; text-align: center; font-weight: bold;">Tot Upstream Bugs</td>
		<td style="vertical-align: top; text-align: center; font-weight: bold;">Avg days open</td>
		 <td style="vertical-align: top; text-align: center; font-weight: bold;">Distrib</td>
      <td style="vertical-align: top;text-align: center; font-weight: bold;">Uscan warnings</td>
    </tr>
<?
        	while ($res_array=pg_fetch_array($rsql)) {
?>
    <tr>
      <td style="vertical-align: top;"><? print $res_array["pop_inst"]; ?><br>
      </td>
      <td style="vertical-align: top;"><a href="/report.php?package=<? print urlencode($res_array["name"]); ?>"><? print htmlentities($res_array["name"]); ?></a><br>
      </td>
	   <td style="vertical-align: top;">
	   <? if ($res_array[up_changes]!='') { ?>
	   		<a href="<? print "wwiz_detail.php?id=$res_array[id]&amp;type=up_changes";?>">
		  	<? print htmlentities($res_array["up_version"]); ?></a><br>
		<?}
		else print $res_array["up_version"].'<br>';?>
      </td>
	   <td style="vertical-align: top;"><? print $res_array["version"]; if ($res_array["dversionmangled"] != $res_array["version"]) {
    echo ' (mangled:&nbsp;<i>' . htmlentities($res_array["dversionmangled"]) . '</i>)';
} ?><br>
      </td>
	  	   <td style="vertical-align: top;"><? print number_format($res_array["tot_up_error"] ,0); ?><br>
      </td>
	  	   <td style="vertical-align: top;"><? print number_format($res_array["tot_avg_error_date"],0); ?><br>
      </td>
	  	   <td style="vertical-align: top;"><? print $res_array["dist"]; ?><br>
      </td>
	  <td style="vertical-align: top;"><? print htmlentities($res_array["watch_warn"]); ?><br>
      </td>
    </tr>
<?
    	}
	pg_close($db);
?>
  </tbody>
</table>
<br>
<i>Last update: <? echo htmlentities(date("r")); ?></i>
<br>
</div>
</body>
</html>
