<?/*

 Originally written by Stefano Fabri <bluefuture@nospam@email.it>
 Copyright 2004, Stefano Fabri

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <meta content="text/html; charset=ISO-8859-1"
 http-equiv="content-type">
  <title>Sources With No Watch</title>
  <link rel="shortcut icon" href="/favicon.ico">
</head>
<body>
<div style="text-align: center;">
<h1><img src="http://www.debian.org/logos/openlogo-nd-50.png" style="border:0px;" alt='' height='30.5px' width='25px'>&nbsp;<a href="http://dehs.alioth.debian.org/" style="color:black;font-size:35px">Debian External Health Status</a>&nbsp;<img src="/earth.png" style="border:0px;" alt='' height='30.5px' width='30.5px'></h1>
Source packages that need watch files - Sorted by popularity<br><br>
<?include("menu.inc");?>
 <?
 $sqlstring="SELECT id,pkgs.pop_inst,name,pkgs.version,pkgs.dist,tot_up_error, tot_avg_error_date,wwiz,wwiz_type,wwiz_version,up_changes FROM pkgs INNER JOIN
(Select SUM(up_error) as tot_up_error,AVG(avg_error_date) as tot_avg_error_date,name,dist FROM binpkgs GROUP BY name,dist) as binpkgs using(name,dist)
WHERE watch IS NULL OR watch=''  ORDER BY pop_inst DESC";
require "config_www.inc";
$rsql=pg_exec($db, $sqlstring);
$rsql2=pg_exec($db, "SELECT count(name) from pkgs");
$totnowatch=pg_numrows($rsql);
$totpkgs=pg_fetch_array($rsql2,0);
$rsql2=pg_exec($db, "SELECT count(name) from pkgs WHERE wwiz_type='watch'");
$watch=pg_fetch_array($rsql2,0);
$rsql2=pg_exec($db, "SELECT count(name) from pkgs WHERE wwiz_type='error'");
$error=pg_fetch_array($rsql2,0);
$rsql2=pg_exec($db, "SELECT count(name) from pkgs WHERE wwiz_type='notmatch'");
$notmatch=pg_fetch_array($rsql2,0);
$rsql2=pg_exec($db, "SELECT count(name) from pkgs WHERE wwiz_type='no_cright'");
$na=pg_fetch_array($rsql2,0);?>
<table
 style="width: auto; text-align: left; margin-left: auto; margin-right: auto;"
 border="0" cellspacing="2" cellpadding="2">
<tbody>
    <tr><td style="vertical-align: top; text-align: center;">
<big>Watch wizard - automatically built watch file from
Copyright file</big></td></tr>
<tr><td style="text-align: left;"><small><b>Watch (<?=$watch[0];?>)-></b>Dehs wizard generated Watch file. It has passed Uscan test</small></td></tr>
<tr><td style="text-align: left;"><small><b>Errors (<?=$error[0];?>)-></b> Error for the dehs wizard Watch file that has not passed Uscan test.</small></td></tr>
<tr><td style="text-align: left;"><small><b>N/A (<?=$na[0];?>)-></b> Copyright files not found.</small></td></tr>
<tr><td style="text-align: left;"><small><b>Notmatch (<?=$notmatch[0];?>)-></b> Copyright file, no http/ftp address found from Watch wizard.</small></td></tr>
</tbody>
</table><br>
<b>Total source packages without watch file</b>: <? print $totnowatch . " "; ?>
<b>Total source packages:</b> <?=$totpkgs[0];?> <b>Share: </b> <? print number_format ( $totnowatch/$totpkgs[0] * 100, 2) . "%" ;?>
<table
 style="width: 70%; text-align: left; margin-left: auto; margin-right: auto;"
 border="1" cellspacing="2" cellpadding="2">
<tbody>
<tr>
<td style="text-align: left; font-weight: bold;">Pop Inst</td>
<td style="text-align: left; font-weight: bold;">Name</td>
<td style="text-align: left; font-weight: bold;">WWizard Version</td>
<td style="text-align: left; font-weight: bold;">Debian Version</td>
<td style="text-align: center; font-weight: bold;">Tot Upstream Bugs</td>
<td style="text-align: center; font-weight: bold;">Avg days open</td>
<td style="text-align: left; font-weight: bold;">Dist</td>
<td style="text-align: left; font-weight: bold;">Watch Wizard</td>
</tr>
<?
	while ($res_array=pg_fetch_array($rsql)) {
?>
<tr>
<td><? print $res_array["pop_inst"]; ?><br></td>
<td><a href="/report.php?package=<? print urlencode($res_array["name"]); ?>"><? print htmlentities($res_array["name"]); ?></a><br></td>
<td>
<? if ($res_array[up_changes]!='' AND is_updated($res_array["wwiz_version"],$res_array["version"])) { ?>
<a href="<? print "wwiz_detail.php?id=$res_array[id]&amp;type=up_changes";?>"><? print htmlentities($res_array["wwiz_version"]); ?></a><br>
	<?}
		else print htmlentities($res_array["wwiz_version"]).'<br>';?>
</td>
<td><? print htmlentities($res_array["version"]); ?><br></td>
<td><? print number_format($res_array["tot_up_error"],0); ?><br>
</td>
<td><? print number_format($res_array["tot_avg_error_date"],0); ?><br>
</td>
<td><? print $res_array["dist"]; ?><br></td>
<td>
<?
if ($res_array["wwiz_type"]!="no_cright") {?>
<a href="<? print "wwiz_detail.php?id=$res_array[id]&amp;type=watch";?>"><? print htmlentities($res_array["wwiz_type"]); ?></a><br>
		  	<?}
		  else print "N/A<br>";
		  ?>
</td>
</tr>
<?
	}
	pg_close($db);
?>
</tbody>
</table>
<br>
<i>Last update: <? echo htmlentities(date("r")); ?></i>
<br>
</div>
</body>
</html>
<?

function is_updated ($up_vers,$debian_vers) {
if ($up_vers=='') return 0;
$up_vers = escapeshellarg($up_vers);
$debian_vers = escapeshellarg(vers_conv($debian_vers));
passthru("dpkg --compare-versions $up_vers le $debian_vers",$great);
if ($great==0) return 1;
else return 0;
}
function vers_conv($debvers) {
    // Strip off the epoch
    $pos = strpos($debvers, ':');
    if ( $pos !== FALSE) {
        $debvers = substr($debvers, $pos+1);
    }

    // strip off the Debian revision (look from the back of the string)
    $pos = strrpos($debvers, '-');
    if ( $pos !== FALSE) {
        $debvers = substr($debvers, 0, $pos);
    }

    // strip off repacking indicators
    $debvers = preg_replace("/[-.+~]?(ds|dfsg|debian)(.*)/i", "", $debvers);
    return $debvers;
}
?>
