<?php

$password = implode('',file('/srv/alioth.debian.org/chroot/home/groups/dehs/.pgpass'));

$dbconn = 'dbname=dehs host=localhost user=dehs password=' .  $password;

unset($password);

$base = '/org/home/groups/dehs/dehs_prj/dehs/';

$dirs = array('diffs_dir'   => $base . 'files/diffs',
              'sources_dir' => $base . 'files/sources',
              'popcon_dir'  => $base . 'files/popcon');

$dists = array(
            unstable     => array('main','contrib','non-free'),
            experimental => array('main','contrib','non-free')
);

$mirrors=array(
            'unstable'     => 'ftp.nl.debian.org',
            'experimental' => 'ftp.nl.debian.org'
);

//list of addresses wishing to receive ALL the emails (even minor/less important reports)
$email_all = 'atomo64@gmail.com';

//list of addresses wishing to be notified when update_all runs
$email = "bluefuture@email.it,filippo@esaurito.net,$email_all";

$uscan = $base . '/uscan.pl';

$sfIgnore = array('dl', 'download', 'prdownload', 'downloads', 'lists', 'cvs', 'svn', 'www');
$watchFileExts = array('tar.*', 'tgz', 'zip', 'gz', 'bz2');
$watchFileDversionMangle = array('cvs', 'svn', 'git', 'snapshot', 'pre', 'hg');
/*1: watch url, 2: $space, 3: name, 4: file ext, 5: extra options*/
$watchFormat = 'version=3' . "\n" . '%5$s' . "\n" . '%1$s%2$s%3$s-?_?([\d+\.]+|\d+)\.%4$s debian uupdate';

$fetchUpstreamChanges = false;
$fetchWatchFromVCS = true;

$sendNotifications = true;
$notificationsMailFrom = 'Debian External Health System <dehs-devel@lists.alioth.debian.org>';

$timeStamp_basedCheck = array('all', 'vcs');
$minimumAge = 5;
$minimumVCSAge = 6;

$_SERVER['SERVER_NAME']=shell_exec("hostname -f 2>&1");
?>